\\
\\  cubeprg.gp
\\
\\  by Takeshi GOTO (Oct. 2005)
\\    URL: http://www.ma.noda.tus.ac.jp/u/tg/perfect.html
\\ 
\\  used to find all pairs (P,Q,R) satisfying
\\    Q^3 | \Phi_R(P), P,Q<10^8, 6680<=R<5 \times 10^7.
\\  output files: mysqrs.txt, mycubes.txt, numchkd.txt
\\
prmdiv(a)=
{
  local(p);
  p=2;
  while(p<=a,
    if(a%p==0,return(p));
    p=nextprime(p+1)
  )
}

modpow(a,b,p)=
{
  local(x);
  x=Mod(a,p)^b;
  return(lift(x))
}

fngen(q)=
{
  local(a,qq,p,c);
  a=2; c=0;
  while(c==0,
    qq=q-1;c=1;
    while(qq>1,
      p=prmdiv(qq);
      if(modpow(a,(q-1)/p,q)==1,c=0);
      while(qq%p==0,qq=qq/p)
    );
    if(c==0,a=a+1)
  );
  if(modpow(a,q-1,q^2)==1,a=a+q);
  return(a)
}

check(f,t)=
{
  local(a,g,q,r);
  r=nextprime(f);
  if(r>t,return("Not a valid interval."));
  while(r<=t,
    print("Checking for R= ",r);
    q=2*r+1;
    while(q<10^8,
      if(isprime(q),
        g=Mod(fngen(q),q^2);
        a=g^(q*(q-1)/r); p=1;
        for(i=1,r-1,
          p=lift(p*a);
          if(p<10^2, write("mysqrs.txt",q,"^2 divides ",p,"^",r,"-1"),
            if(p<10^8 && isprime(p) && modpow(p,r,q^3)==1,
              print(q,"^3 divides ",p,"^",r,"-1");
              write("mycubes.txt",q,"^3 divides ",p,"^",r,"-1")
            )
          )
        )
      );
      q=q+2*r
    );
    r=nextprime(r+1)
  );
  write("numchkd.txt","Checked R= ",f," to R= ",t)
} 
